<?php
namespace Internetgalerie\IgMessages\Domain\Model;


/***
 *
 * This file is part of the "IG Messages" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2020 
 *
 ***/
/**
 * Mailbox
 */
class Mailbox extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * isNew
     * 
     * @var bool
     */
    protected $isNew = true;

    /**
     * isDone
     * 
     * @var bool
     */
    protected $isDone = false;

    /**
     * message
     * 
     * @var \Internetgalerie\IgMessages\Domain\Model\Message
     */
    protected $message = null;

    /**
     * frontendUser
     * 
     * @var \TYPO3\CMS\Extbase\Domain\Model\FrontendUser
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $frontendUser = null;

    /**
     * Returns the isNew
     * 
     * @return bool $isNew
     */
    public function getIsNew()
    {
        return $this->isNew;
    }

    /**
     * Sets the isNew
     * 
     * @param bool $isNew
     * @return void
     */
    public function setIsNew($isNew)
    {
        $this->isNew = $isNew;
    }

    /**
     * Returns the boolean state of isNew
     * 
     * @return bool
     */
    public function isIsNew()
    {
        return $this->isNew;
    }

    /**
     * Returns the message
     * 
     * @return \Internetgalerie\IgMessages\Domain\Model\Message $message
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * Sets the message
     * 
     * @param \Internetgalerie\IgMessages\Domain\Model\Message $message
     * @return void
     */
    public function setMessage(\Internetgalerie\IgMessages\Domain\Model\Message $message)
    {
        $this->message = $message;
    }

    /**
     * Returns the isDone
     * 
     * @return bool isDone
     */
    public function getIsDone()
    {
        return $this->isDone;
    }

    /**
     * Sets the isDone
     * 
     * @param string $isDone
     * @return void
     */
    public function setIsDone($isDone)
    {
        $this->isDone = $isDone;
    }

    /**
     * Returns the frontendUser
     * 
     * @return \TYPO3\CMS\Extbase\Domain\Model\FrontendUser frontendUser
     */
    public function getFrontendUser()
    {
        return $this->frontendUser;
    }

    /**
     * Sets the frontendUser
     * 
     * @param \TYPO3\CMS\Extbase\Domain\Model\FrontendUser $frontendUser
     * @return void
     */
    public function setFrontendUser(\TYPO3\CMS\Extbase\Domain\Model\FrontendUser $frontendUser)
    {
        $this->frontendUser = $frontendUser;
    }
}
