<?php
namespace Internetgalerie\IgMessages\Domain\Model;

use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Utility\GeneralUtility;
/**
 * Message
 */
class Message extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * partial
     * 
     * @var string
     */
    protected $partial = '';

    /**
     * title
     * 
     * @var string
     */
    protected $title = '';

    /**
     * titleFr
     * 
     * @var string
     */
    protected $titleFr = '';

    /**
     * body
     * 
     * @var string
     */
    protected $body = '';

    /**
     * bodyFr
     * 
     * @var string
     */
    protected $bodyFr = '';

    /**
     * isSend
     * 
     * @var bool
     */
    protected $isSend = false;

    /**
     * sendDate
     * 
     * @var \DateTime
     */
    protected $sendDate = null;

    /**
     * frontendUser
     * 
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FrontendUser>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $frontendUser = null;

    /**
     * frontendUserGroup
     * 
     * @var int
     */
    protected $frontendUserGroup = null;

    /**
     * tags
     * 
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgMessages\Domain\Model\Tag>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $tags = null;

    
    /**
     * Returns the title
     * 
     * @return string $title
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * Sets the title
     * 
     * @param string $title
     * @return void
     */
    public function setTitle($title)
    {
        $this->title = $title;
    }

    public function getTitleLang()
    {
        return $GLOBALS['TSFE']->lang =='fr' ? $this->titleFr : $this->title;
    }

    /**
     * Returns the titleFr
     * 
     * @return string $titleFr
     */
    public function getTitleFr()
    {
        return $this->titleFr;
    }

    /**
     * Sets the titleFr
     * 
     * @param string $titleFr
     * @return void
     */
    public function setTitleFr($titleFr)
    {
        $this->titleFr = $titleFr;
    }
    
    /**
     * Returns the body
     * 
     * @return string $body
     */
    public function getBody()
    {
        return $this->body;
    }

    public function getBodyLang()
    {
        return $GLOBALS['TSFE']->lang =='fr' ? $this->bodyFr : $this->body;
    }

    /**
     * Sets the body
     * 
     * @param string $body
     * @return void
     */
    public function setBody($body)
    {
        $this->body = $body;
    }

    
    /**
     * Returns the bodyFr
     * 
     * @return string $bodyFr
     */
    public function getBodyFr()
    {
        return $this->bodyFr;
    }

    /**
     * Sets the bodyFr
     * 
     * @param string $bodyFr
     * @return void
     */
    public function setBodyFr($bodyFr)
    {
        $this->bodyFr = $bodyFr;
    }

    /**
     * Returns the isSend
     * 
     * @return bool $isSend
     */
    public function getIsSend()
    {
        return $this->isSend;
    }

    /**
     * Sets the isSend
     * 
     * @param bool $isSend
     * @return void
     */
    public function setIsSend($isSend)
    {
        $this->isSend = $isSend;
    }

    /**
     * Returns the boolean state of isSend
     * 
     * @return bool
     */
    public function isIsSend()
    {
        return $this->isSend;
    }

    /**
     * Returns the sendDate
     * 
     * @return \DateTime $sendDate
     */
    public function getSendDate()
    {
        return $this->sendDate;
    }

    /**
     * Sets the sendDate
     * 
     * @param \DateTime $sendDate
     * @return void
     */
    public function setSendDate(\DateTime $sendDate)
    {
        $this->sendDate = $sendDate;
    }

    /**
     * __construct
     */
    public function __construct()
    {

        //Do not remove the next line: It would break the functionality
        $this->initStorageObjects();
    }

    /**
     * Initializes all ObjectStorage properties
     * Do not modify this method!
     * It will be rewritten on each save in the extension builder
     * You may modify the constructor of this class instead
     * 
     * @return void
     */
    protected function initStorageObjects()
    {
        $this->frontendUser = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->tags = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
    }

    /**
     * Adds a FrontendUser
     * 
     * @param \TYPO3\CMS\Extbase\Domain\Model\FrontendUser $frontendUser
     * @return void
     */
    public function addFrontendUser(\TYPO3\CMS\Extbase\Domain\Model\FrontendUser $frontendUser)
    {
        $this->frontendUser->attach($frontendUser);
    }

    /**
     * Removes a FrontendUser
     * 
     * @param \TYPO3\CMS\Extbase\Domain\Model\FrontendUser $frontendUserToRemove The FrontendUser to be removed
     * @return void
     */
    public function removeFrontendUser(\TYPO3\CMS\Extbase\Domain\Model\FrontendUser $frontendUserToRemove)
    {
        $this->frontendUser->detach($frontendUserToRemove);
    }

    /**
     * Returns the frontendUser
     * 
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FrontendUser> $frontendUser
     */
    public function getFrontendUser()
    {
        return $this->frontendUser;
    }

    /**
     * Sets the frontendUser
     * 
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FrontendUser> $frontendUser
     * @return void
     */
    public function setFrontendUser(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $frontendUser)
    {
        $this->frontendUser = $frontendUser;
    }

    /**
     * Returns the frontendUserGroup
     * 
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FrontendUserGroup> $frontendUserGroup
     */
    public function getFrontendUserGroup()
    {
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('tx_igmessages_message_frontendusergroup_mm');
        $result = $queryBuilder
                ->select('uid_foreign')
                ->from('tx_igmessages_message_frontendusergroup_mm')
                ->where(
                    $queryBuilder->expr()->eq(
                        'uid_local',
                        $queryBuilder->createNamedParameter($this->uid, \PDO::PARAM_INT)
                    )
                )
                ->executeQuery();
        $data=[];
        while($row=$result->fetchAssociative()) {
            $data[]=['uid' => $row['uid_foreign']];
        }
        return $data;
        //return $result->fetchAll();
    }

    /**
     * Sets the frontendUserGroup
     * 
     * @param array $frontendUserGroupUids
     * @return void
     */
    public function setFrontendUserGroup(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $frontendUserGroup)
    {
        //$this->frontendUserGroup = $frontendUserGroup;
    }

    /**
     * Returns the partial
     * 
     * @return string partial
     */
    public function getPartial()
    {
        return $this->partial;
    }

    /**
     * Sets the partial
     * 
     * @param string $partial
     * @return void
     */
    public function setPartial($partial)
    {
        $this->partial = $partial;
    }

    /**
     * Adds a Tag
     * 
     * @param \Internetgalerie\IgMessages\Domain\Model\Tag $tag
     * @return void
     */
    public function addTag(\Internetgalerie\IgMessages\Domain\Model\Tag $tag)
    {
        $this->tags->attach($tag);
    }

    /**
     * Removes a Tag
     * 
     * @param \Internetgalerie\IgMessages\Domain\Model\Tag $tagToRemove The Tag to be removed
     * @return void
     */
    public function removeTag(\Internetgalerie\IgMessages\Domain\Model\Tag $tagToRemove)
    {
        $this->tags->detach($tagToRemove);
    }

    /**
     * Returns the tags
     * 
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgMessages\Domain\Model\Tag> $tags
     */
    public function getTags()
    {
        return $this->tags;
    }

    /**
     * Sets the tags
     * 
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgMessages\Domain\Model\Tag> $tags
     * @return void
     */
    public function setTags(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $tags)
    {
        $this->tags = $tags;
    }
    public function getUsers()
    {
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('fe_users');
        $result = $queryBuilder
                ->select('*')
                ->from('fe_users')
                ->executeQuery();
        $tagValues = [];
        foreach($this->tags as $tag) {
            $tagValues[] = $tag->getValue();
        }
        //$tagValues=['81005'];
        $frontendUserGroups = [];
        foreach($this->getFrontendUserGroup() as $frontendUserGroup) {
            $frontendUserGroups[]=$frontendUserGroup['uid'];
        }
        $data = [];
        while($row=$result->fetchAssociative()) {
            if(!$this->hasNumber($row['cnum'], $tagValues)) {
                continue;
            }
            
            if(!$this->inUsergroup($row['usergroup'], $frontendUserGroups)) {
                continue;
            }
            //var_dump($tagValues, $usergroup,$writeNumbders,$row );            exit(0);
            //echo($row['username']. ' ' .  $row['uid']  . '<br />');
            $data[]=[
                'uid' => $row['uid'],
                'username' => $row['username'],
                'cnum' => $row['cnum'],
            ];
        }
        return $data;
    }
    // Hat Benutzer Rechte auf angegebene Betriebe
    public function hasNumber(?string $cnum, array $tagValues)
    {
        if(empty($tagValues)) {
                return true;
        }
        if($cnum===null) {
            return false;
        }
        $writeNumbders =  explode(',', $cnum);
        foreach($writeNumbders as $writeNumbder) {
            foreach($tagValues as $tagValue) {
                $length = strlen($tagValue);
                $compare = substr($writeNumbder, 0, $length);
                if($compare == $tagValue) {
                    return true;
                }
            }
            /*
            $compare = substr($writeNumbder,0,1);
            if(in_array($compare, $tagValues)) {
                return true;
            }
            */
        }
        return false;
    }
    public function getUsersNotSend()
    {
        $usersNotSend = [];
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable( 'tx_igmessages_domain_model_mailbox' );
        foreach($this->getUsers() as $user) {
            $res = $queryBuilder
                 ->select('uid')
                 ->from('tx_igmessages_domain_model_mailbox')
                 ->where(
                     $queryBuilder->expr()->eq(
                         'message',
                         $queryBuilder->createNamedParameter($this->uid, \PDO::PARAM_INT)
                     ),
                     $queryBuilder->expr()->eq(
                         'frontend_user',
                         $queryBuilder->createNamedParameter($user['uid'], \PDO::PARAM_INT)
                     )
                 )->executeQuery();
            if($res->fetchAssociative()) {
                continue;
            }
            $usersNotSend[] = $user;
        }

        return $usersNotSend;
    }
    // Ist Benutzer in einer der angegebenen Gruppen
    public function inUsergroup(string $usergroup, array $frontendUserGroups )
    {
        if(empty($frontendUserGroups)) {
                return true;
        }
        $userGroups = explode(',' , $usergroup);
        foreach($userGroups as $userGroup) {
        if(in_array($userGroup, $frontendUserGroups)) {
                return true;
            }
        }
        return false;
    }
    public function getMails()
    {
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('tx_igmessages_domain_model_mailbox');
        $result = $queryBuilder
                ->addSelectLiteral(
                    $queryBuilder->expr()->count('uid', 'anzahl')
                )
                //->select('count(1) AS anzahl')
                ->from('tx_igmessages_domain_model_mailbox')
                 ->where(
                     $queryBuilder->expr()->eq(
                         'message',
                         $queryBuilder->createNamedParameter($this->getUid(), \PDO::PARAM_INT)
                     )
                 )
                ->executeQuery();
        $row = $result->fetchAssociative();
        return $row['anzahl'];
    }
    public function getMailsNew()
    {
        return $this->getMailsIsNew(1);
    }
    public function getMailsRead()
    {
        return $this->getMailsIsNew(0);
    }
    public function getMailsIsNew($isNew)
    {
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('tx_igmessages_domain_model_mailbox');
        $result = $queryBuilder
                ->addSelectLiteral(
                    $queryBuilder->expr()->count('uid', 'anzahl')
                )
                //->select('count(1) AS anzahl')
                ->from('tx_igmessages_domain_model_mailbox')
                 ->where(
                     $queryBuilder->expr()->eq(
                         'message',
                         $queryBuilder->createNamedParameter($this->getUid(), \PDO::PARAM_INT)
                     ),
                     $queryBuilder->expr()->eq(
                         'is_new',
                         $queryBuilder->createNamedParameter($isNew, \PDO::PARAM_INT)
                     )
                 )
                ->executeQuery();
        $row = $result->fetchAssociative();
        return $row['anzahl'];
    }
    public function getMailsDone()
    {
        return $this->getMailsIsDone(1);
    }
    public function getMailsIsDone($isDone)
    {
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('tx_igmessages_domain_model_mailbox');
        $result = $queryBuilder
                ->addSelectLiteral(
                    $queryBuilder->expr()->count('uid', 'anzahl')
                )
                //->select('count(1) AS anzahl')
                ->from('tx_igmessages_domain_model_mailbox')
                 ->where(
                     $queryBuilder->expr()->eq(
                         'message',
                         $queryBuilder->createNamedParameter($this->getUid(), \PDO::PARAM_INT)
                     ),
                     $queryBuilder->expr()->eq(
                         'is_done',
                         $queryBuilder->createNamedParameter($isDone, \PDO::PARAM_INT)
                     )
                 )
                ->executeQuery();
        $row = $result->fetchAssociative();
        return $row['anzahl'];
    }
}
